/**
 * \file
 *
 * \brief SAM D20/D21/R21 EEPROM͕핔
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "eeprom.h"
#include <string.h>
#include <nvm.h>

/**
 * \internal
 * @̌ASCIIŘA"AtEEPROMEmu."łB̌͊ȒPȐr̐Ƃ
 * Ď邱ƂłǍx̂߂32ޯĒl̘AƂĕ
 * ܂B
 */
#define EEPROM_MAGIC_KEY				{0x41744545, 0x50524f4d, 0x456d752e}

/** \internal
 *  32ޯėvfł̖@̌̒
 */
#define EEPROM_MAGIC_KEY_COUNT			3

COMPILER_PACK_SET(1);
/**
 * \internal
 * \brief EEPROM͕߰ނLq\
 */
struct _eeprom_master_page {
	uint32_t magic_key[EEPROM_MAGIC_KEY_COUNT];		/**< ASCIIł̖@̌AtEEPROMEmuƂĎx܂B */

	uint8_t  major_version;							/**< ͕핔ŏ */
	uint8_t  minor_version;							/**< ͕핔ŏ */
	uint8_t  revision;								/**< ͕핔ŏ */

	uint8_t  emulator_id;							/**< (Ԕԍ`Ⴄ͕핔̎dg݊Ԃʂ邽߂)͕핔ʒl */

	uint8_t  reserved[45];							/**< ߰ޓ̖gp\޲ */
};

/**
 * \internal
 * \brief ͕킵EEPROMް߰ނLq\
 */
struct _eeprom_page {
	struct {							/**< EEPROM߰ނ̐擪 */
		uint8_t logical_page;
		uint8_t reserved[EEPROM_HEADER_SIZE - 1];
	} header;

	uint8_t data[EEPROM_PAGE_SIZE];		/**< EEPROM߰ންe */
};
COMPILER_PACK_RESET();

/**
 * \internal
 * \brief ޲̍\
 */
struct _eeprom_module {
	bool initialized;							/**< EEPROM͕핔̏ */

	const struct _eeprom_page *flash;			/**< ͕EEPROMi[ׯ̐擪޲Ăւ̐޲Ĉʒuwq */

	uint16_t physical_pages;					/**< EEPOROM͕핔ɂĐL镨Iׯ ߰ސ */
	uint8_t  logical_pages;						/**< EEPOROM͕핔ɂĐL_Iׯ ߰ސ */

	uint8_t page_map[EEPROM_MAX_PAGES / 2 - 4];	/**< _EEPROM߰ނ̔z𕨗Iׯ ߰ނɊ蓖 */

	uint8_t spare_row;							/**< (݂̏ɂĎgp)\p̗ԍ */

	struct _eeprom_page cache;					/**< ݷꂽ߰ނێ邽߂̊ɏՕ */
	bool cache_active;							/**< Lް܂ނB */
};

/**
 * \internal
 * \brief EEPROM͕핔
 */
static struct _eeprom_module _eeprom_instance = {
	.initialized = false,
};


/** \internal
 *  \brief IEEPROM؋ԓŗ^ꂽ
 *
 *  \param[in]  row EEPROMԓ̕
 */
static void _eeprom_emulator_nvm_erase_row(
		const uint8_t row)
{
	enum status_code error_code = STATUS_OK;

	do {
		error_code = nvm_erase_row(
				(uint32_t)&_eeprom_instance.flash[row * NVMCTRL_ROW_PAGES]);
	} while (error_code == STATUS_BUSY);
}

/** \internal
 *  \brief IEEPROM؋ԂœNVM߰ފɏՕ𖞂B
 *
 *  \param[in]  physical_page EEPOROMԓ߰̕
 *  \param[in]  data           ߰ނɏް
 */
static void _eeprom_emulator_nvm_fill_cache(
		const uint16_t physical_page,
		const void* const data)
{
	enum status_code error_code = STATUS_OK;

	do {
		error_code = nvm_write_buffer(
				(uint32_t)&_eeprom_instance.flash[physical_page],
				(uint8_t*)data,
				NVMCTRL_PAGE_SIZE);
	} while (error_code == STATUS_BUSY);
}

/** \internal
 *  \brief NVM߰ފɏՕ𕨗؂Ɉn
 *
 *  \param[in]  physical_page nEEPROMԓ߰̕
 */
static void _eeprom_emulator_nvm_commit_cache(
		const uint16_t physical_page)
{
	enum status_code error_code = STATUS_OK;

	do {
		error_code = nvm_execute_command(
				NVM_COMMAND_WRITE_PAGE,
				(uint32_t)&_eeprom_instance.flash[physical_page], 0);
	} while (error_code == STATUS_BUSY);
}

/** \internal
 *  \brief EEPROM؋ԂŊi[ꂽް߰ǂݍ
 *
 *  \param[in]   physical_page ǂEEPROMԓ߰̕
 *  \param[out]  data          ǂްŖ]ɏՕ
 */
static void _eeprom_emulator_nvm_read_page(
		const uint16_t physical_page,
		void* const data)
{
	enum status_code error_code = STATUS_OK;

	do {
		error_code = nvm_read_buffer(
				(uint32_t)&_eeprom_instance.flash[physical_page],
				(uint8_t*)data,
				NVMCTRL_PAGE_SIZE);
	} while (error_code == STATUS_BUSY);
}

/**
 * \brief ͕EEPROM؏Aݓej
 */
static void _eeprom_emulator_format_memory(void)
{
	uint16_t logical_page = 0;

	/* \Ƃė0ݒ */
	_eeprom_instance.spare_row = 0;
	_eeprom_emulator_nvm_erase_row(_eeprom_instance.spare_row);

	for (uint16_t physical_page = NVMCTRL_ROW_PAGES;
			physical_page < _eeprom_instance.physical_pages; physical_page++) {

		if (physical_page == EEPROM_MASTER_PAGE_NUMBER) {
			continue;
		}

		/* V̐擪߰ނȂAŜ */
		if ((physical_page % NVMCTRL_ROW_PAGES) == 0) {
			_eeprom_emulator_nvm_erase_row(physical_page / NVMCTRL_ROW_PAGES);
		}

		/* 2̘_߰͊eŊi[Aċ󔒂̖͕EEPROM߰ނ̑g̑΂ŏ܂B */
		if ((physical_page % NVMCTRL_ROW_PAGES) < 2) {
			/* EEPROM߰ނێ߂̊ɏՕ쐬 */
			struct _eeprom_page data;
			memset(&data, 0xFF, sizeof(data));

			/* VEEPROM̐擪\ݒ */
			data.header.logical_page = logical_page;

			/* ߰ނ𕨗؂ɏo */
			_eeprom_emulator_nvm_fill_cache(physical_page, &data);
			_eeprom_emulator_nvm_commit_cache(physical_page);

			/* ⌻݂߰ނA_EEPROM߰ ڽ𑝉 */
			logical_page++;
		}
	}
}

/**
 * \brief _EEPROM߰ނ𕨗ׯ ߰ނɕϊ邽߂SRAMɒn}쐬
 */
static void _eeprom_emulator_update_page_mapping(void)
{
	/* Ƙ_߰ޒn}̂߁AS߰ނʂđ */
	for (uint16_t c = 0; c < _eeprom_instance.physical_pages; c++) {
		if (c == EEPROM_MASTER_PAGE_NUMBER) {
			continue;
		}

		/* ݂߰̕ނŊi[ꂽ_߰ނœǂݍ */
		uint16_t logical_page = _eeprom_instance.flash[c].header.logical_page;

		/* _߰ޔԍLȂA蓖Ă̂߂ɂǉ */
		if ((logical_page != EEPROM_INVALID_PAGE_NUMBER) &&
				(logical_page < _eeprom_instance.logical_pages)) {
			_eeprom_instance.page_map[logical_page] = c;
		}
	}

	/* Lȕ܂ŗ\ƂĖ߰ޔԍgp */
	_eeprom_instance.spare_row = EEPROM_INVALID_ROW_NUMBER;

	/* \ƂĎĝɏ邽߁ASʂđ */
	for (uint16_t c = 0; c < (_eeprom_instance.physical_pages / NVMCTRL_ROW_PAGES); c++) {
		bool spare_row_found = true;

		/* 炪SďĂ邩m邽߂ɗ߰ʂĔ */
		for (uint8_t c2 = 0; c2 < NVMCTRL_ROW_PAGES; c2++) {
			uint16_t physical_page = (c * NVMCTRL_ROW_PAGES) + c2;

			if (physical_page == EEPROM_MASTER_PAGE_NUMBER) {
				continue;
			}

			if (_eeprom_instance.flash[physical_page].header.logical_page !=
					EEPROM_INVALID_PAGE_NUMBER) {
				spare_row_found = false;
			}
		}

		/* \񔭌Ai[Č~ */
		if (spare_row_found == true) {
			_eeprom_instance.spare_row = c;
			break;
		}
	}
}

/**
 * \brief 1p\ȂA^ꂽŎ̋߰ނB
 *
 * \param[in]   start_physical_page ̕ׯ ߰ގwW
 * \param[out]  free_physical_page  (Ă)݋̕ׯ ߰ނ
 *                                  wW
 *
 * \return w肵ŋ߰ނǂ
 *
 * \retval \c true  ߰ނꍇ
 * \retval \c false w肵񂪖tŏKvȏꍇ
 */
static bool _eeprom_emulator_is_page_free_on_row(
		const uint8_t start_physical_page,
		uint8_t *const free_physical_page)
{
	/* ߰ޔԍׯƗ߰ނɕϊ */
	uint8_t row         = (start_physical_page / NVMCTRL_ROW_PAGES);
	uint8_t page_in_row = (start_physical_page % NVMCTRL_ROW_PAGES);

	/* ݎgꂽȂ߰ނɑ΂錻݂̗𒲂ׂ܂B */
	for (uint8_t c = page_in_row; c < NVMCTRL_ROW_PAGES; c++) {
		/* 錻݂߰ނɑ΂߰ޔԍvZ */
		uint8_t page = (row * NVMCTRL_ROW_PAGES) + c;

		/* ߰ނȂAĂяoɓnĔo */
		if (_eeprom_instance.flash[page].header.logical_page ==
				EEPROM_INVALID_PAGE_NUMBER) {
			*free_physical_page = page;
			return true;
		}
	}

	/* ݂̗ŋ߰ނSȂB */
	return false;
}

/**
 * \brief ްw肵_߰ނ\Ɉړ
 *
 * ̗čĎgpł悤Ɏw肵̓e\Ɉړ܂B^
 * ꂽ_߰ނ̓e͐VɏՕްŒu܂B
 *
 * \param[in]  row_number   ׂ镨
 * \param[in]  logical_page XV̘_EEPROM߰ޔԍ
 * \param[in]  data         _߰ނŋްuVް
 *
 * \return ̏Ԃԕ
 */
static enum status_code _eeprom_emulator_move_data_to_spare(
		const uint8_t row_number,
		const uint8_t logical_page,
		const uint8_t *const data)
{
	enum status_code error_code = STATUS_OK;
	struct {
		uint8_t logical_page;
		uint8_t physical_page;
	} page_trans[2];

	const struct _eeprom_page *row_data =
			(struct _eeprom_page *)&_eeprom_instance.flash[row_number * NVMCTRL_ROW_PAGES];

	/* 邢͕̉(E[̔łŐV)Ŋeɉ2̘_ް ߰ނ
	 * ׂłB[2߰ނŐV߰މ܂ނƉ肷邱Ƃɂ
	 * ĊJn܂B */
	page_trans[0].logical_page  = row_data[0].header.logical_page;
	page_trans[0].physical_page = (row_number * NVMCTRL_ROW_PAGES);

	page_trans[1].logical_page  = row_data[1].header.logical_page;
	page_trans[1].physical_page = (row_number * NVMCTRL_ROW_PAGES) + 1;

	/* Ŋi[ꂽ2̘_߰ނ̍ŐVT܂B */
	for (uint8_t c = 0; c < 2; c++) {
		/* ǂꂩ̂Vɑ΂ėŎc߰ނʂĒׂ܂B */
		for (uint8_t c2 = 2; c2 < NVMCTRL_ROW_PAGES; c2++) {
			if (page_trans[c].logical_page == row_data[c2].header.logical_page) {
				page_trans[c].physical_page =
						(row_number * NVMCTRL_ROW_PAGES) + c2;
			}
		}
	}

	/* Ŋi[ĕۑꂽ̘_߰ނ̈ړKv */
	for (uint8_t c = 0; c < 2; c++) {
		/* VԂ̗߰ނɑ΂镨߰ގwWB */
		uint32_t new_page =
				((_eeprom_instance.spare_row * NVMCTRL_ROW_PAGES) + c);

		/* ꂩ̷ް𕨗s؂ɈnB */
		eeprom_emulator_commit_page_buffer();

		/* ߰ނȂAړ쒆ɕύX]֐Ăт܂B */
		if (logical_page == page_trans[c].logical_page) {
			/* ŐV(XVꂽ)_߰ނ̐擪L */
			_eeprom_instance.cache.header.logical_page = logical_page;

			/* ްSRAMɏ */
			memcpy(_eeprom_instance.cache.data, data, EEPROM_PAGE_SIZE);
		} else {
			/* EEPROM߰ނ𖳍ʂɷɏՕɕ */
			_eeprom_emulator_nvm_read_page(
					page_trans[c].physical_page, &_eeprom_instance.cache);
		}

		/* d͏Ԃ̂߂ɕKvƂꍇɏɂꂪfn
		 * ɐVްNVMɏՕ𖞂܂B */
		_eeprom_emulator_nvm_fill_cache(new_page, &_eeprom_instance.cache);

		/* V߰ވʒu߰ޒn}XVAⷬ͐Vްێ
		 * Ƃ܂B */
		_eeprom_instance.page_map[page_trans[c].logical_page] = new_page;
		_eeprom_instance.cache_active = true;
	}

	/* ړꂽĂV\ƂĐݒ */
	_eeprom_emulator_nvm_erase_row(row_number);

	/* V\̎wWێ */
	_eeprom_instance.spare_row = row_number;

	return error_code;
}

/**
 * \brief ͕EEPROMǗ߰ނ쐬
 *
 * EEPROMްi[̂Ɏgp͕핔̏^͕EEPROM̐V
 * ߰ނ쐬܂B
 */
static void _eeprom_emulator_create_master_page(void)
{
	const uint32_t magic_key[] = EEPROM_MAGIC_KEY;

	struct _eeprom_master_page master_page;
	memset(&master_page, 0xFF, sizeof(master_page));

	/* ꂽ߰ނ߂ɖ@̌擪L */
	for (uint8_t c = 0; c < EEPROM_MAGIC_KEY_COUNT; c++) {
		master_page.magic_key[c] = magic_key[c];
	}

	/* ̖͕핔̔ŏƋɎ擪XV */
	master_page.emulator_id   = EEPROM_EMULATOR_ID;
	master_page.major_version = EEPROM_MAJOR_VERSION;
	master_page.minor_version = EEPROM_MINOR_VERSION;
	master_page.revision      = EEPROM_REVISION;

	_eeprom_emulator_nvm_erase_row(
			EEPROM_MASTER_PAGE_NUMBER / NVMCTRL_ROW_PAGES);

	/* V߰ ް𕨗؂ɏ */
	_eeprom_emulator_nvm_fill_cache(EEPROM_MASTER_PAGE_NUMBER, &master_page);
	_eeprom_emulator_nvm_commit_cache(EEPROM_MASTER_PAGE_NUMBER);
}

/**
 * \brief EEPROM߰ނ̓emF
 *
 * ꂪEEPROM͕޽̂̔łɑ΂鐳܂ނƂۏ؂邽߂Ɏ
 * EEPROM߰ނ̓emF܂B
 *
 * \retval STATUS_OK             ^ꂽ߰ޓeL
 * \retval STATUS_ERR_BAD_FORMAT ߰ޓe
 * \retval STATUS_ERR_IO         ߰ންEEPROM͕핔łƖ
 */
static enum status_code _eeprom_emulator_verify_master_page(void)
{
	const uint32_t magic_key[] = EEPROM_MAGIC_KEY;
	struct _eeprom_master_page master_page;

	/* ꂪł悤Ɏ߰ނRAMɏՕɕ */
	_eeprom_emulator_nvm_read_page(EEPROM_MASTER_PAGE_NUMBER, &master_page);

	/* ߰ސ擪Ŗ@̌ƂmF */
	for (uint8_t c = 0; c < EEPROM_MAGIC_KEY_COUNT; c++) {
		if (master_page.magic_key[c] != magic_key[c]) {
			return STATUS_ERR_BAD_FORMAT;
		}
	}

	/* dg݂gp邱ƕۏ؂邽߂ɐ擪Ŗ͕핔IDmF */
	if (master_page.emulator_id   != EEPROM_EMULATOR_ID) {
		return STATUS_ERR_IO;
	}

	/* Ŏgp邱ƕۏ؂邽߂ɐ擪ŎłmF */
	if (master_page.major_version != EEPROM_MAJOR_VERSION) {
		return STATUS_ERR_IO;
	}

	/* Ŏgp邱ƕۏ؂邽߂ɐ擪ŕłmF */
	if (master_page.minor_version != EEPROM_MINOR_VERSION) {
		return STATUS_ERR_IO;
	}

	/* ԍ͊mF܂B - i[ꂽްv邱Ƃۏ؂邽߂
	 * /łŏ[ƌ􂳂܂B */

	return STATUS_OK;
}


/**
 * \brief EEPROM͕핔ؔzuҰ擾
 *
 * ꂪꂽAEEPROM͕핔̌`ԐݒҰ擾
 *
 * \param[out]  parameters EEPORM͕핔Ұ\
 *
 * \return ̏
 *
 * \retval STATUS_OK                  ͕핔ҰɎ擾܂B
 * \retval STATUS_ERR_NOT_INITIALIZED EEPROM͕핔͏Ă܂B
 */
enum status_code eeprom_emulator_get_parameters(
	struct eeprom_emulator_parameters *const parameters)
{
	if (_eeprom_instance.initialized == false) {
		return STATUS_ERR_NOT_INITIALIZED;
	}

	parameters->page_size              = EEPROM_PAGE_SIZE;
	parameters->eeprom_number_of_pages = _eeprom_instance.logical_pages;

	return STATUS_OK;
}

/**
 * \brief EEPROM͕핔޽
 *
 * ͕킷EEPROMԂA͕킷EEPROM؂ɏĂꍇA
 * \ref eeprom_emulator_erase_memory()oRŖI̫ϯĂKv
 * BEEPROM؋Ԃ́A޽ɏłȂꍇɎ蓮Ŏgp҉p
 * ĕIް꓾邩Ȃ悤ɁA֐ɂĎI
 * ɏ\b܂B
 *
 * \return ̏Ԃԕ
 *
 * \retval STATUS_OK             EEPROM͕޽͐ɏ܂B
 * \retval STATUS_ERR_NO_MEMORY  EEPROM̈悪޲Ŋ蓖ĂĂ܂B
 * \retval STATUS_ERR_BAD_FORMAT ͕EEPROM؂s܂͖̫ϯ
 * \retval STATUS_ERR_IO         EEPROMްEEPROM͕핔̂̔ł̎dg݂Ɩ
 */
enum status_code eeprom_emulator_init(void)
{
	enum status_code error_code = STATUS_OK;
	struct nvm_config config;
	struct nvm_parameters parameters;

	/* NVM`Ԑݒ擾 - ߂ɖ͕핔߰ޏ݂̑S
	 * rIɐ䂷悤ɁA蓮߰ޏݓ */
	nvm_get_config_defaults(&config);
	config.manual_page_write = true;

	/* VNVM`ԐݒKp */
	do {
		error_code = nvm_set_config(&config);
	} while (error_code == STATUS_BUSY);

	/* NVM`ԐݒҰ擾 */
	nvm_get_parameters(&parameters);

	/* ޲˭ނƍŒ1̎߰ޗA1̎gpEEPROMް1̗\
	 * Ɍ`Ԑݒ肳̂ۏ */
	if (parameters.eeprom_number_of_pages < (3 * NVMCTRL_ROW_PAGES)) {
		return STATUS_ERR_NO_MEMORY;
	}

	/* EEPROM̂̕Ƙ_߰ސ`Ԑݒ:
	 *  - 1̗񂪎߰ނɗ\񂳂܂B
	 *  - 1̗񂪗\ɗ\񂳂܂B
	 *  - 1̕2̘_߰ނi[邱Ƃł܂B
	 */
	_eeprom_instance.physical_pages =
			parameters.eeprom_number_of_pages;
	_eeprom_instance.logical_pages  =
			(parameters.eeprom_number_of_pages - (2 * NVMCTRL_ROW_PAGES)) / 2;

	/* ׯEEPROM̊JnڽEEPROMɎgp\ߌvZׯ
	 * ̐擪߰ނ̎wW */
	_eeprom_instance.flash =
			(void*)(FLASH_SIZE -
			((uint32_t)_eeprom_instance.physical_pages * NVMCTRL_PAGE_SIZE));

	/* EEPROM߰ޏݷ */
	_eeprom_instance.cache_active = false;

	/* ׯEEPROMް̘_߰ނzu邽߂ɕ؂𑖍Ę_
	 * 畨ւ߰ފ蓖ĕ\č쐬 */
	_eeprom_emulator_update_page_mapping();

	/* \񂪌܂B - ؂ŝ悤Ɏv̂Œ~ */
	if (_eeprom_instance.spare_row == EEPROM_INVALID_ROW_NUMBER) {
		return STATUS_ERR_BAD_FORMAT;
	}

	/* ߰ނ̻޽ɂėLް܂ނƂmF */
	error_code = _eeprom_emulator_verify_master_page();
	if (error_code != STATUS_OK) {
		return error_code;
	}

	/* ƂďLB */
	_eeprom_instance.initialized = true;

	return error_code;
}

/**
 * \brief ͕EEPROM؋ԑŜ
 *
 * ͕EEPROM؋ԂďAްj
 */
void eeprom_emulator_erase_memory(void)
{
	/* EEPROM͕̈ŐVEEPROM؉쐬 */
	_eeprom_emulator_format_memory();

	/* EEPROM͕啔 */
	_eeprom_emulator_create_master_page();

	/* V쐬ꂽEEPROM؉蓖 */
	_eeprom_emulator_update_page_mapping();
}

/**
 * \brief ް߰ނ͕EEPROM ߰ނɏ
 *
 * ͕EEPROM߰ން͕EEPROM؋Ԃɏ
 *
 * \note ߰ނɊi[ꂽް͊RAM؂ɷ邩ꂸAǂ̷
 *       ꂽްs؂Ɉn߂
 *       \ref eeprom_emulator_commit_page_buffer()֐Ă΂ׂłB
 *
 * \param[in]  logical_page _EEPROM߰ޔԍ
 * \param[in]  data         ް܂ްɏՕւ̈ʒuwq
 *
 * \return ̏Ԃԕ
 *
 * \retval STATUS_OK                  ߰ނɓǂ߂ꍇ
 * \retval STATUS_ERR_NOT_INITIALIZED EEPROM͕핔ĂȂꍇ
 * \retval STATUS_ERR_BAD_ADDRESS     LȖ͕EEPROM؋ԊOڽ
 *                                    ꍇ
 */
enum status_code eeprom_emulator_write_page(
		const uint8_t logical_page,
		const uint8_t *const data)
{
	/* ͕EEPROMɏ̂ۏ */
	if (_eeprom_instance.initialized == false) {
		return STATUS_ERR_NOT_INITIALIZED;
	}

	/* ݱڽeڽԓł邱Ƃۏ */
	if (logical_page >= _eeprom_instance.logical_pages) {
		return STATUS_ERR_BAD_ADDRESS;
	}

	/* Ō̷݂ ߰ނ߰ނłȂ(łȂ
	 * ΁AnĐV߰ނ𷬯)𒲍 */
	if ((_eeprom_instance.cache_active == true) &&
			(_eeprom_instance.cache.header.logical_page != logical_page)) {
		/* ̷݂ ްɏՕs؂ɈnB */
		eeprom_emulator_commit_page_buffer();
	}

	/* Vłɑ΂Č݂߰ʒu̕ŋԂ𒲂ׁAȂΐV
	 * ߰ގwW擾 */
	uint8_t new_page = 0;
	bool page_spare  = _eeprom_emulator_is_page_free_on_row(
			_eeprom_instance.page_map[logical_page], &new_page);

	/* ݂̗񂪖tł\ƌ邱ƂKv𒲍 */
	if (page_spare == false) {
		/* ߰ވړA߰ނŊi[ꂽ̂VɏAÂ
		 * ݂߰ނV߰ޓeŒu܂(͍悤ɍXV
		 * )B */
		_eeprom_emulator_move_data_to_spare(
				_eeprom_instance.page_map[logical_page] / NVMCTRL_ROW_PAGES,
				logical_page,
				data);

		/* VްķXVAo */
		return STATUS_OK;
	}

	/* V߰ސ擪߰ 擪̈XV */
	_eeprom_instance.cache.header.logical_page = logical_page;

	/* Vް߰ eXV */
	memcpy(&_eeprom_instance.cache.data,
			data,
			EEPROM_PAGE_SIZE);

	/* d͏Ԃ̂߂ɕKvƂꍇɂꂪőfn悤
	 * VްŕNVMɏՕ𖞂B */
	_eeprom_emulator_nvm_fill_cache(new_page, &_eeprom_instance.cache);

	/*  װҰXVķƋLB */
	_eeprom_instance.page_map[logical_page] = new_page;
	barrier();	// sȷԂh߂ɐ{
	_eeprom_instance.cache_active           = true;

	return STATUS_OK;
}

/**
 * \brief ͕EEPROM ߰ން߰ނǂݍ
 *
 * ͕EEPROM؋Ԃ͕EEPROMް߰ނǂݍ
 *
 * \param[in]   logical_page ǂޘ_EEPROM߰ޔԍ
 * \param[out]  data         ]ްɏՕւ̈ʒuwq
 *
 * \return ̏Ԃԕ
 *
 * \retval STATUS_OK                  ߰ނɓǂ܂ꂽꍇ
 * \retval STATUS_ERR_NOT_INITIALIZED EEPROM͕핔ĂȂꍇ
 * \retval STATUS_ERR_BAD_ADDRESS     LȖ͕EEPROM؋ԊOڽ
 *                                    ꍇ
 */
enum status_code eeprom_emulator_read_page(
		const uint8_t logical_page,
		uint8_t *const data)
{
	/* ͕EEPROMɏ̂ۏ */
	if (_eeprom_instance.initialized == false) {
		return STATUS_ERR_NOT_INITIALIZED;
	}

	/* ǂݍݱڽeڽԓł邱Ƃۏ */
	if (logical_page >= _eeprom_instance.logical_pages) {
		return STATUS_ERR_BAD_ADDRESS;
	}

	/* ǂ߰ނݷĂ(AĐݓIɓO/؂V
	 * )𒲍 */
	if ((_eeprom_instance.cache_active == true) &&
		 (_eeprom_instance.cache.header.logical_page == logical_page)) {
		/* ݓIɂVꂽްgpҊɏՕ֕ */
		memcpy(data, _eeprom_instance.cache.data, EEPROM_PAGE_SIZE);
	} else {
		struct _eeprom_page temp;

		/* s؂ްꎞɏՕɕ */
		_eeprom_emulator_nvm_read_page(
				_eeprom_instance.page_map[logical_page], &temp);

		/* ǂ߰ންgp҂̊ɏՕɕ */
		memcpy(data, temp.data, EEPROM_PAGE_SIZE);
	}

	return STATUS_OK;
}

/**
 * \brief ɏՕް͕EEPROM؋Ԃɏ
 *
 * ɏՕް͕EEPROM؋Ԃ̗̈ɏ܂B]ɏՕ͉ꂩ̑傫
 * ꂸA]͖͕EEPROM߰ދE̊Oɂ邩܂B
 *
 * \note ߰ޓɊi[ް͊RAM؂ɷꂤꂸAꂩ
 *       ꂽް𕨗Iȕs؂Ɉnɂ́A 
 *       \ref eeprom_emulator_commit_page_buffer()֐Ă΂ׂłB
 *
 * \param[in]  offset ͕EEPROM؋ԂŏJn޲ĕψ
 * \param[in]  data   ް܂ްɏՕւ̈ʒuwq
 * \param[in]  length ޲Ăł̏ް̒
 *
 * \return ̏Ԃԕ
 *
 * \retval STATUS_OK                  ߰ނɓǂ܂ꂽꍇ
 * \retval STATUS_ERR_NOT_INITIALIZED EEPROM͕핔ĂȂꍇ
 * \retval STATUS_ERR_BAD_ADDRESS     LȖ͕EEPROM؋ԊOڽ
 *                                    ꍇ
 */
enum status_code eeprom_emulator_write_buffer(
		const uint16_t offset,
		const uint8_t *const data,
		const uint16_t length)
{
	enum status_code error_code = STATUS_OK;
	uint8_t buffer[EEPROM_PAGE_SIZE];
	uint8_t logical_page = offset / EEPROM_PAGE_SIZE;
	uint16_t c = offset;
	/* ݍXVꂽ߰ނꂽǂ̌o܂ێ */
	bool page_dirty = false;
	/** KvȂ΁A߰ޓǂݍ݂s */
	if ((offset % EEPROM_PAGE_SIZE) || length < EEPROM_PAGE_SIZE) {
		error_code = eeprom_emulator_read_page(logical_page, buffer);

		if (error_code != STATUS_OK) {
			return error_code;
		}
	}

	/* JԂ̏̏ꍇɓɓ̂邽 */
	if ((offset % EEPROM_PAGE_SIZE) == 0) {
		buffer[c % EEPROM_PAGE_SIZE] = data[c - offset];
		page_dirty = true;
		c=c+1;
	}

	/* w肵ް͕EEPROM؋Ԃɏ */
	for (; c < (length + offset); c++) {
		/* VEEPROM߰ދE֏グ */
		if ((c % EEPROM_PAGE_SIZE) == 0) {
			/* ꎞɏՕ猻݂߰ނs؂ɏ */
			error_code = eeprom_emulator_write_page(logical_page, buffer);
			page_dirty = false;

			if (error_code != STATUS_OK) {
				break;
			}

			/* Ă߰ޔԍ𑝉 */
			logical_page++;

			/* I߰ޏ݂̏ꍇAs؂ꎞɏՕ֎߰
			 * ǂݍ */
			error_code = eeprom_emulator_read_page(logical_page, buffer);

			if (error_code != STATUS_OK) {
				return error_code;
			}
		}
		/* gp҂̊ɏՕް̎޲ĂꎞɏՕ֕ */
		buffer[c % EEPROM_PAGE_SIZE] = data[c - offset];
		page_dirty = true;
	}

	/* ݂߰ނsȂAB */
	if (page_dirty) {
		error_code = eeprom_emulator_write_page(logical_page, buffer);
	}

	return error_code;
}

/**
 * \brief ͕EEPROM؋ԂɏՕްǂݍ
 *
 * ͕EEPROM؋Ԃ̗̈悩ɏՕްǂ݂܂B]ɏՕ͉ꂩ̑
 * ꂸA]͖͕EEPROM߰ދE̊Oɂ邩܂B
 *
 * \param[in]  offset ͕EEPROM؋ԂœǂފJn޲ĕψ
 * \param[in]  data   ǂތް܂ްɏՕւ̈ʒuwq
 * \param[in]  length ޲Ăł̓ǂް̒
 *
 * \return ̏Ԃԕ
 *
 * \retval STATUS_OK                  ߰ނɓǂ܂ꂽꍇ
 * \retval STATUS_ERR_NOT_INITIALIZED EEPROM͕핔ĂȂꍇ
 * \retval STATUS_ERR_BAD_ADDRESS     LȖ͕EEPROM؋ԊOڽ
 *                                    ꍇ
 */
enum status_code eeprom_emulator_read_buffer(
		const uint16_t offset,
		uint8_t *const data,
		const uint16_t length)
{
	enum status_code error_code;
	uint8_t buffer[EEPROM_PAGE_SIZE];
	uint8_t logical_page = offset / EEPROM_PAGE_SIZE;
	uint16_t c = offset;

	/** ŏ߰ޓǂݍ݂s */
	error_code = eeprom_emulator_read_page(logical_page, buffer);
	if (error_code != STATUS_OK) {
		return error_code;
	}

	/* JԂ̏̏ꍇɓɓ̂邽 */
	if ((offset % EEPROM_PAGE_SIZE) == 0) {
		data[0] = buffer[0];
		c=c+1;
	}

	/* ͕EEPROM؋Ԃw肵ްǂݍ */
	for (; c < (length + offset); c++) {
		/* VEEPROMҰދEɓǂݏグ */
		if ((c % EEPROM_PAGE_SIZE) == 0) {
			/* Ă߰ޔԍ𑝉 */
			logical_page++;

			/* s؂ꎞɏՕ֎߰ނǂݍ */
			error_code = eeprom_emulator_read_page(logical_page, buffer);

			if (error_code != STATUS_OK) {
				return error_code;
			}
		}

		/* ꎞɏՕgp҂̊ɏՕް̎޲Ă𕡎 */
		data[c - offset] = buffer[c % EEPROM_PAGE_SIZE];
	}

	return error_code;
}

/**
 * \brief ꂩ̷ ް𕨗Iȕs؂ɈnB
 *
 * ǂ̖ ްی삳̂ۏ؂邽߁ASRAM𕨗Iȕs
 * ؂Ɉn܂B̊֐ްh߂ɼ ؾĂ܂͓df
 * ɐ旧ČĂ΂ׂłB
 *
 * \note ͖̂ǂ̷ ްްh߂ɊSɏ邱Ƃ
 *       ۏ؂邽߂ɁABOD33xĂі߂Ŏsŏ̊֐łׂ
 *       łB
 *
 *
 * \note ̊֐ްh߂ɑ̂ǂ̖ړIɑ΂Ăgp҉pŒ
 *       NVMgpOɂĂ΂ׂłB
 *
 * \return ̏Ԃԕ
 */
enum status_code eeprom_emulator_commit_page_buffer(void)
{
	enum status_code error_code = STATUS_OK;

	/* sȂA؂ɉnKv͂܂B */
	if (_eeprom_instance.cache_active == false) {
		return STATUS_OK;
	}

	uint8_t cached_logical_page = _eeprom_instance.cache.header.logical_page;

	/* NVM߰ފɏՕׯɈn߂߰ޏ݂s */
	_eeprom_emulator_nvm_commit_cache(
			_eeprom_instance.page_map[cached_logical_page]);

	barrier();	// sȷԂh߂ɐ{
	_eeprom_instance.cache_active = false;

	return error_code;
}
