/**
 * \file
 *
 * \brief SAM D20/D21/R21 TC - v/vײ
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "tc.h"

#if TC_ASYNC == true
#  include "tc_interrupt.h"
#  include <system_interrupt.h>

/** \internal
 * ^ꂽTCwW̊荞޸wWɕϊ
 */
#  define _TC_INTERRUPT_VECT_NUM(n, unused) \
		SYSTEM_INTERRUPT_MODULE_TC##n,
#endif

#if !defined(__DOXYGEN__)
#  define _TC_GCLK_ID(n,unused)           TPASTE3(TC,n,_GCLK_ID)   ,
#  define _TC_PM_APBCMASK(n,unused)       TPASTE2(PM_APBCMASK_TC,n) ,

#  define TC_INST_GCLK_ID          { MRECURSION(TC_INST_NUM, _TC_GCLK_ID, TC_INST_MAX_ID) }
#  define TC_INST_PM_APBCMASK      { MRECURSION(TC_INST_NUM, _TC_PM_APBCMASK, TC_INST_MAX_ID) }

#endif

/**
 * \internal ^ꂽTCPʕ̂̎wWB
 *
 * \param[in]  hw TCPʕ̈ʒuwq
 *
 * \return ^ꂽTCPʕ̂̎wW
 */
uint8_t _tc_get_inst_index(
		Tc *const hw)
{
	/* p\TCPʕ̈ꗗ */
	Tc *const tc_modules[TC_INST_NUM] = TC_INSTS;

	/* TC̗pwWB */
	for (uint32_t i = 0; i < TC_INST_NUM; i++) {
		if (hw == tc_modules[i]) {
			return i;
		}
	}

	/* ^ꂽް */
	Assert(false);
	return 0;
}


/**
 * \brief ʰ޳TCPʕ̂
 *
 * ^ꂽ`ԐݒlɊÂĸۯTCPʕ܂B
 *
 * \param[in,out]  module_inst ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]      hw          TCʰ޳Pʕւ̈ʒuwq
 * \param[in]      config      TC`ԐݒCӑI\̂ւ̈ʒuwq
 *
 * \return 葱̏
 *
 * \retval STATUS_OK          Pʕ͐ɏ܂B
 * \retval STATUS_BUSY        葱݂ꂽʰ޳Pʕ͑Z
 *                            B
 * \retval STATUS_INVALID_ARG Ȍ`ԐݒCӑI܂͈܂B
 * \retval STATUS_ERR_DENIED  ʰ޳PʕɋĂA܂ʰ޳
 *                            Pʕ32ޯď]ғŌ`ԂĂ܂B
 */
enum status_code tc_init(
		struct tc_module *const module_inst,
		Tc *const hw,
		const struct tc_config *const config)
{
	/*  */
	Assert(hw);
	Assert(module_inst);
	Assert(config);

	/* 炪ɏOCTRLAڼ޽ւ̑SĂ̍XVێꎞϐ */
	uint16_t ctrla_tmp = 0;
	/* 炪ɏOCTRLBSETڼ޽ւ̑SĂ̍XVێꎞϐ */
	uint8_t ctrlbset_tmp = 0;
	/* 炪ɏOCTRLCڼ޽ւ̑SĂ̍XVێꎞϐ */
	uint8_t ctrlc_tmp = 0;
	/* TC̔ԍێꎞϐ */
	uint8_t instance = _tc_get_inst_index(hw);

	/* eTĈɑ΂GLCK ID̔z */
	uint8_t inst_gclk_id[] = TC_INST_GCLK_ID;
	/* eTĈɑ΂PM APBCՕޯĈʒu̔z */
	uint16_t inst_pm_apbmask[] = TC_INST_PM_APBCMASK;

	struct system_pinmux_config pin_config;
	struct system_gclk_chan_config gclk_chan_config;

#if TC_ASYNC == true
	/* Ұ */
	for (uint8_t i = 0; i < TC_CALLBACK_N; i++) {
		module_inst->callback[i]        = NULL;
	}
	module_inst->register_callback_mask     = 0x00;
	module_inst->enable_callback_mask       = 0x00;

	/* ̎̂Ăі߂ɑ΂ēo^ */
	_tc_instances[instance] = module_inst;
#endif

	/* ^ꂽ޲̂ʰ޳PʕƘAg */
	module_inst->hw = hw;

	/* TCPʕ32ޯėʌvŌ`Ԑݒ肳邩Bv킾
	 * 32ޯėʌvŌ`Ԑݒ肳邱Ƃ܂B
	 */
	if ((config->counter_size == TC_COUNTER_SIZE_32BIT) &&
			((instance + TC_INSTANCE_OFFSET) & 0x01)) {
		Assert(false);
		return STATUS_ERR_INVALID_ARG;
	}

	/* Pʕ̌v̑傫𔽉fmodule_insťv̑傫ϐ쐬
	 */
	module_inst->counter_size = config->counter_size;

	if (hw->COUNT8.CTRLA.reg & TC_CTRLA_SWRST) {
		/* ؾĂ̒ԂłB~ */
		return STATUS_BUSY;
	}

	if (hw->COUNT8.STATUS.reg & TC_STATUS_SLAVE) {
		/* Pʕ͏]҂ƂĎgpĂ܂B */
		return STATUS_ERR_DENIED;
	}

	if (hw->COUNT8.CTRLA.reg & TC_CTRLA_ENABLE) {
		/* Pʕ͏̑Oɋ֎~Ȃ΂Ȃ܂B~ */
		return STATUS_ERR_DENIED;
	}

	/* 0ɑ΂TC PWMo݂\ݒ */
	if (config->pwm_channel[0].enabled) {
		system_pinmux_get_config_defaults(&pin_config);
		pin_config.mux_position = config->pwm_channel[0].pin_mux;
		pin_config.direction = SYSTEM_PINMUX_PIN_DIR_OUTPUT;
		system_pinmux_pin_set_config(
				config->pwm_channel[0].pin_out, &pin_config);
	}

	/* 1ɑ΂TC PWMo݂\ݒ */
	if (config->pwm_channel[1].enabled) {
		system_pinmux_get_config_defaults(&pin_config);
		pin_config.mux_position = config->pwm_channel[1].pin_mux;
		pin_config.direction = SYSTEM_PINMUX_PIN_DIR_OUTPUT;
		system_pinmux_pin_set_config(
				config->pwm_channel[1].pin_out, &pin_config);
	}

	/* PMŎgpҲ̪ ۯ */
	system_apb_clock_set_mask(SYSTEM_CLOCK_APB_APBC,
			inst_pm_apbmask[instance]);

	/* v̑傫32ޯĂȂΏ]v */
	if ((config->counter_size == TC_COUNTER_SIZE_32BIT))
	{
		/* PMŎgpҲ̪ ۯ */
		system_apb_clock_set_mask(SYSTEM_CLOCK_APB_APBC,
				inst_pm_apbmask[instance + 1]);
	}

	/* Pʕpۯ\ݒ */
	system_gclk_chan_get_config_defaults(&gclk_chan_config);
	gclk_chan_config.source_generator = config->clock_source;
	system_gclk_chan_set_config(inst_gclk_id[instance], &gclk_chan_config);
	system_gclk_chan_enable(inst_gclk_id[instance]);

	/* CTRLAڼ޽ݒ */
	ctrla_tmp =
			(uint32_t)config->counter_size |
			(uint32_t)config->wave_generation |
			(uint32_t)config->reload_action |
			(uint32_t)config->clock_prescaler;

	if (config->run_in_standby) {
		ctrla_tmp |= TC_CTRLA_RUNSTDBY;
	}

	/* `Ԑݒڼ޽ɏ */
	while (tc_is_syncing(module_inst)) {
		/* ҂ */
	}
	hw->COUNT8.CTRLA.reg = ctrla_tmp;

	/* CTRLBڼ޽ݒ */
	if (config->oneshot) {
		ctrlbset_tmp = TC_CTRLBSET_ONESHOT;
	}

	if (config->count_direction) {
		ctrlbset_tmp |= TC_CTRLBSET_DIR;
	}

	/* CTRLB`Ԑݒ */
	while (tc_is_syncing(module_inst)) {
		/* ҂ */
	}
	hw->COUNT8.CTRLBCLR.reg = 0xFF;

	/* ۂɑ҂ԂɂȂ̂Kv */
	if (ctrlbset_tmp) {
		while (tc_is_syncing(module_inst)) {
			/* ҂ */
		}
		/* `Ԑݒڼ޽ɏ */
		hw->COUNT8.CTRLBSET.reg = ctrlbset_tmp;
	}

	/* CTRLCڼ޽ݒ */
	ctrlc_tmp = config->waveform_invert_output;
	for (uint8_t i = 0; i < NUMBER_OF_COMPARE_CAPTURE_CHANNELS; i++) {
		if (config->enable_capture_on_channel[i] == true) {
			ctrlc_tmp |= (TC_CTRLC_CPTEN(1) << i);
		}
	}

	/* `Ԑݒڼ޽ɏ */
	while (tc_is_syncing(module_inst)) {
		/* ҂ */
	}
	hw->COUNT8.CTRLC.reg = ctrlc_tmp;

	/* `Ԑݒڼ޽ɏ */
	while (tc_is_syncing(module_inst)) {
		/* ҂ */
	}

	/* TCv̑傫؂ւ */
	switch (module_inst->counter_size) {
		case TC_COUNTER_SIZE_8BIT:
			while (tc_is_syncing(module_inst)) {
				/* ҂ */
			}

			hw->COUNT8.COUNT.reg =
					config->counter_8_bit.value;


			while (tc_is_syncing(module_inst)) {
				/* ҂ */
			}

			hw->COUNT8.PER.reg =
					config->counter_8_bit.period;

			while (tc_is_syncing(module_inst)) {
				/* ҂ */
			}

			hw->COUNT8.CC[0].reg =
					config->counter_8_bit.compare_capture_channel[0];

			while (tc_is_syncing(module_inst)) {
				/* ҂ */
			}

			hw->COUNT8.CC[1].reg =
					config->counter_8_bit.compare_capture_channel[1];

			return STATUS_OK;

		case TC_COUNTER_SIZE_16BIT:
			while (tc_is_syncing(module_inst)) {
				/* ҂ */
			}

			hw->COUNT16.COUNT.reg
				= config->counter_16_bit.value;

			while (tc_is_syncing(module_inst)) {
				/* ҂ */
			}

			hw->COUNT16.CC[0].reg =
					config->counter_16_bit.compare_capture_channel[0];

			while (tc_is_syncing(module_inst)) {
				/* ҂ */
			}

			hw->COUNT16.CC[1].reg =
					config->counter_16_bit.compare_capture_channel[1];

			return STATUS_OK;

		case TC_COUNTER_SIZE_32BIT:
			while (tc_is_syncing(module_inst)) {
				/* ҂ */
			}

			hw->COUNT32.COUNT.reg
				= config->counter_32_bit.value;

			while (tc_is_syncing(module_inst)) {
				/* ҂ */
			}

			hw->COUNT32.CC[0].reg =
					config->counter_32_bit.compare_capture_channel[0];

			while (tc_is_syncing(module_inst)) {
				/* ҂ */
			}

			hw->COUNT32.CC[1].reg =
					config->counter_32_bit.compare_capture_channel[1];

			return STATUS_OK;
	}

	Assert(false);
	return STATUS_ERR_INVALID_ARG;
}

/**
 * \brief TCPʕvlݒ
 *
 * ꂽPʕ݂̌̌vvlݒ肵܂Bw肵TCPʕ͊Jn
 * ͒~Ă邩܂B
 *
 * \param[in]  module_inst ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  count       ݒ肷Vvvl
 *
 * \return vXV葱̏
 *
 * \retval STATUS_OK              vv͐ɍXV܂B
 * \retval STATUS_ERR_INVALID_ARG Ȍvvw肳܂B
 */
enum status_code tc_set_count_value(
		const struct tc_module *const module_inst,
		const uint32_t count)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tc *const tc_module = module_inst->hw;

	while (tc_is_syncing(module_inst)) {
		/* ҂ */
	}

	/* TCv̑傫ɊÂď */
	switch (module_inst->counter_size) {
		case TC_COUNTER_SIZE_8BIT:
			tc_module->COUNT8.COUNT.reg  = (uint8_t)count;
			return STATUS_OK;

		case TC_COUNTER_SIZE_16BIT:
			tc_module->COUNT16.COUNT.reg = (uint16_t)count;
			return STATUS_OK;

		case TC_COUNTER_SIZE_32BIT:
			tc_module->COUNT32.COUNT.reg = (uint32_t)count;
			return STATUS_OK;

		default:
			return STATUS_ERR_INVALID_ARG;
	}
}

/**
 * \brief TCPʕvl擾
 *
 * TCPʕ݂̌̌vl擾܂Bw肵TCPʕ͊Jn܂͒~Ă
 * 邩܂B
 *
 * \param[in]  module_inst ĳPʕ̍\̂ւ̈ʒuwq
 *
 * \return w肵TCPʕ̌vl
 */
uint32_t tc_get_count_value(
		const struct tc_module *const module_inst)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tc *const tc_module = module_inst->hw;

	while (tc_is_syncing(module_inst)) {
		/* ҂ */
	}

	/* TCv̑傫ɊÂēǂݍ */
	switch (module_inst->counter_size) {
		case TC_COUNTER_SIZE_8BIT:
			return (uint32_t)tc_module->COUNT8.COUNT.reg;

		case TC_COUNTER_SIZE_16BIT:
			return (uint32_t)tc_module->COUNT16.COUNT.reg;

		case TC_COUNTER_SIZE_32BIT:
			return tc_module->COUNT32.COUNT.reg;
	}

	Assert(false);
	return 0;
}

/**
 * \brief TCPʕߊll擾
 *
 * ꂽTCPʕߊlٓ̕ߊll擾܂B
 *
 * \param[in]  module_inst   ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  channel_index ǂޔr/ߊlق̎wW
 *
 * \return w肵vقŊi[ꂽߊll
 */
uint32_t tc_get_capture_value(
		const struct tc_module *const module_inst,
		const enum tc_compare_capture_channel channel_index)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tc *const tc_module = module_inst->hw;

	while (tc_is_syncing(module_inst)) {
		/* ҂ */
	}

	/* TCv̑傫ɊÂēǂݏo */
	switch (module_inst->counter_size) {
		case TC_COUNTER_SIZE_8BIT:
			if (channel_index <
					NUMBER_OF_COMPARE_CAPTURE_CHANNELS) {
				return tc_module->COUNT8.CC[channel_index].reg;
			}

		case TC_COUNTER_SIZE_16BIT:
			if (channel_index <
					NUMBER_OF_COMPARE_CAPTURE_CHANNELS) {
				return tc_module->COUNT16.CC[channel_index].reg;
			}

		case TC_COUNTER_SIZE_32BIT:
			if (channel_index <
					NUMBER_OF_COMPARE_CAPTURE_CHANNELS) {
				return tc_module->COUNT32.CC[channel_index].reg;
			}
	}

	Assert(false);
	return 0;
}

/**
 * \brief TCPʕrlݒ
 *
 * rlTCPʕr/ߊlقɏ܂B
 *
 * \param[in]  module_inst   ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  channel_index r/ߊlق̎wW
 * \param[in]  compare       ݒ肷Vrl
 *
 * \return rXV葱̏
 *
 * \retval  STATUS_OK              rl͐ɍXV܂B
 * \retval  STATUS_ERR_INVALID_ARG َwW܂B
 */
enum status_code tc_set_compare_value(
		const struct tc_module *const module_inst,
		const enum tc_compare_capture_channel channel_index,
		const uint32_t compare)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);
	Assert(compare);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tc *const tc_module = module_inst->hw;

	while (tc_is_syncing(module_inst)) {
		/* ҂ */
	}

	/* TCv̑傫ɊÂēǂݏo */
	switch (module_inst->counter_size) {
		case TC_COUNTER_SIZE_8BIT:
			if (channel_index <
					NUMBER_OF_COMPARE_CAPTURE_CHANNELS) {
				tc_module->COUNT8.CC[channel_index].reg  =
						(uint8_t)compare;
				return STATUS_OK;
			}

		case TC_COUNTER_SIZE_16BIT:
			if (channel_index <
					NUMBER_OF_COMPARE_CAPTURE_CHANNELS) {
				tc_module->COUNT16.CC[channel_index].reg =
						(uint16_t)compare;
				return STATUS_OK;
			}

		case TC_COUNTER_SIZE_32BIT:
			if (channel_index <
					NUMBER_OF_COMPARE_CAPTURE_CHANNELS) {
				tc_module->COUNT32.CC[channel_index].reg =
						(uint32_t)compare;
				return STATUS_OK;
			}
	}

	return STATUS_ERR_INVALID_ARG;
}

/**
 * \brief TCPʕؾ
 *
 * TCPʕؾāASĂʰ޳Pʕڼ޽̊lɕĒPʕ
 * ~܂BTCPʕؾĂsԱs\łB
 *
 * \note 32ޯČvؾĎATCPʕ̎̍\̂֐ɓnׂ
 *       B
 *
 * \param[in]  module_inst ĳPʕ̍\̂ւ̈ʒuwq
 *
 * \return 葱̏
 * \retval STATUS_OK                  Pʕ͐ؾĂ܂B
 * \retval STATUS_ERR_UNSUPPORTED_DEV 32ޯď]TCPʕ֐ɓn܂BTC
 *                                    łؾĂgpĂB
 */
enum status_code tc_reset(
		const struct tc_module *const module_inst)
{
	/*   */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	TcCount8 *const tc_module = &(module_inst->hw->COUNT8);

	if (tc_module->STATUS.reg & TC_STATUS_SLAVE) {
		return STATUS_ERR_UNSUPPORTED_DEV;
	}

	/* ꂪsĂꍇɂ̒Pʕ֎~ */
	if (tc_module->CTRLA.reg & TC_CTRLA_ENABLE) {
		tc_disable(module_inst);
		while (tc_is_syncing(module_inst)) {
			/* Pʕ֎~̊ԑ҂ */
		}
	}

	/* TCPʕؾ */
	tc_module->CTRLA.reg  |= TC_CTRLA_SWRST;

	return STATUS_OK;
}

/**
 * \brief vTOP/̒lݒ
 *
 * 8ޯėʌvɂĂ̊֐͎ڼ޽TOPl܂B
 *
 * 1632ޯėʌvɂĂ̊֐͔r/ߊlڼ޽0TOPl܂Bڼ
 * ̒l͑̂ǂ̖ړIɂgp邱Ƃł܂B
 *
 * \note ̊֐PWMƎgvłgp悤ɐ݌vĂ܂Bv
 *       킪16܂32ޯėʌvɐݒ肳ƁA[:]B8ޯėʌv
 *       ł͕WłTOPl̒lύX邱Ƃɉ\łB
 *
 * \param[in]  module_inst  ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  top_value    ݒ肷VvTOPl
 *
 * \return TOPݒ葱̏
 *
 * \retval STATUS_OK              vTOPl͐ɍXV܂B
 * \retval STATUS_ERR_INVALID_ARG `Ԑݒ肷Pʕ̓TCPʕv̑
 *                                łB
 */
enum status_code tc_set_top_value (
		const struct tc_module *const module_inst,
		const uint32_t top_value)
{
	Assert(module_inst);
	Assert(module_inst->hw);
	Assert(top_value);

	Tc *const tc_module = module_inst->hw;

	while (tc_is_syncing(module_inst)) {
		/* ҂ */
	}

	switch (module_inst->counter_size) {
		case TC_COUNTER_SIZE_8BIT:
			tc_module->COUNT8.PER.reg    = (uint8_t)top_value;
			return STATUS_OK;

		case TC_COUNTER_SIZE_16BIT:
			tc_module->COUNT16.CC[0].reg = (uint16_t)top_value;
			return STATUS_OK;

		case TC_COUNTER_SIZE_32BIT:
			tc_module->COUNT32.CC[0].reg = (uint32_t)top_value;
			return STATUS_OK;

		default:
			Assert(false);
			return STATUS_ERR_INVALID_ARG;
	}
}
